# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices/configuration.html#application-related-configuration
parameters:
    product_images_directory: '%kernel.project_dir%/public/uploads/images/product/product'
    product_category_images_directory: '%kernel.project_dir%/public/uploads/images/product/category'
    product_subcategory_images_directory: '%kernel.project_dir%/public/uploads/images/product/subcategory'
    product_brand_images_directory: '%kernel.project_dir%/public/uploads/images/product/brand'

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/*'
        exclude: '../src/{DependencyInjection,Entity,Migrations,Tests,Kernel.php}'

    App\Model\User\Entity\User\UserRepository: ~
    App\Model\Product\Entity\Product\ProductRepository: ~
    App\Model\Product\Entity\Product\BrandRepository: ~
    App\Model\Product\Entity\Product\CategoryRepository: ~
    App\Model\Product\Entity\Product\SubcategoryRepository: ~
    App\Model\Product\Entity\Order\OrderRepository: ~
    # controllers are imported separately to make sure services can be injected
    # as action arguments even if you don't extend any base controller class
    App\Controller\:
        resource: '../src/Controller'
        tags: ['controller.service_arguments']

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones
    Finesse\SwiftMailerDefaultsPlugin\SwiftMailerDefaultsPlugin:
        arguments:
            $defaults:
                from:
                    '%env(MAILER_FROM_EMAIL)%': '%env(MAILER_FROM_NAME)%'
        tags:
            - { name: swiftmailer.default.plugin }

    App\Widget\:
        resource: '../src/Widget'
        tags: ['twig.extension']

